unit destruct;
(**
  Ohjelma, jolla demonstroidaan virtuaalisen destruktorin toimintaa
  ja eroja C++:n ja Delphin vlill.

  Miika Nurminen, 3.6.2004.
*)
interface

type

A = class(TObject)
  protected
    name:string;
    procedure println(s:string);
  public
    constructor Create(name:string);
    destructor Destroy; override; // TObject sislt virtuaalisen destruktorin
    procedure doIt; virtual;
end;

B = class(A)
  public
    constructor Create(name:string);
    destructor Destroy; override;
    procedure doIt; override;
end;

implementation


{ A }

constructor A.Create(name: string);
begin
  println('A:n konstruktori alkaa');
  self.name:=name;
  println('A:n konstruktori pttyy');
end;

destructor A.Destroy;
begin
  println('A:n destruktori alkaa');
  doIt();  // luokkaa ei 'pureta', kuten C++:ssa
  println(' ^--- HUOM!');
  inherited;
  println('A:n destruktori pttyy');
end;

procedure A.doIt;
begin
  println('A::doIt');
end;

procedure A.println(s: string);
begin
  writeln(s);
end;


{ B }

// voidaan jtt mys kokonaan pois
constructor B.Create(name: string);
begin
  println('B:n konstruktori alkaa');
  inherited; // tai inherited Create(name);
  println('B:n konstruktori pttyy');
end;

destructor B.Destroy;
begin
  println('B:n destruktori alkaa');
  doIt();
  inherited;  // yliluokan destruktoria ei kutsuta automaattisesti!
  println('B:n destruktori pttyy');
end;

procedure B.doIt;
begin
  println('B::doIt');
end;

end.
